unit Unit1;

interface

uses
  Windows, Messages, SysUtils, StrUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, PasLibVlcPlayerUnit, PasLibVlcUnit;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Label1: TLabel;
    Timer2: TTimer;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  State_on: boolean= false;
  VlcPlayer: array[1..40] of TPasLibVlcPlayer;
  VP_x,VP_y,VP_n, Pause_switch, Num_Active: integer;
  TV_URLs, TV_Names: TStrings;
  Timer_first_finish: boolean;
  URL_Count, Last_URL, Last_MNTR, First_URL: integer;
  mntr: array[1..40] of record
    active: boolean;
    m_x,m_y: integer;
    url: string;
  end;
  urls: array[1..250] of record
    mntr_idx: integer;
    url: string;
    name: string;
  end;
  vlc_stats, prev_vlc_stats: array[1..40] of libvlc_media_stats_t;


implementation

uses unit2;
{$R *.dfm}

procedure ParseM3UPlayList(M3U: string; var Names: TStrings; var URLs: TStrings);
var
  TMPstr: TStrings;
  i: integer;
  s: string;
begin
  TMPstr := TStringList.Create;
  TMPstr.NameValueSeparator := ',';

  if ( M3U[1]=#$ef) and (M3U[2]=#$bb) and (M3U[3]=#$bf)
     then TMPstr.Text := UTF8ToAnsi(M3U)
     else TMPstr.Text := M3U;

  Names.Clear;
  URLs.Clear;
  for i := 0 to TMPstr.Count - 1 do begin
    s := TMPstr.Strings[i];
    if s = '' then continue;
    if AnsiContainsText(s,'#extm3u') then continue;
    if not AnsiContainsText(s,'#extinf') then begin
       URLs.Append(s);
    end
    else begin
      Names.Append(Trim(TMPstr.ValueFromIndex[i]));
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  i, j: integer;
  TmpStr: TStrings;
begin
  VP_n := 0;
  Form2 := TForm2.Create(Self);
  if Form2.ShowModal = mrOk then begin
    VP_x := StrToInt(Form2.Edit1.Text);
    VP_y := StrToInt(Form2.Edit2.Text);
    Num_Active := VP_y * VP_x;
    if Num_Active > 40 then begin
      ShowMessage('  ( 40) : '+IntToStr(Num_Active));
      Halt;
    end;
    ShowMessage('-    : '+IntToStr(Num_Active));

    Pause_Switch := StrToInt(Form2.Edit5.Text);
    for i := 1 to VP_y do begin
      for j := 1 to VP_x do begin
        inc(VP_n);
        VlcPlayer[VP_n] := TPasLibVlcPlayer.CreateParented(Form1.Handle);
        VlcPlayer[VP_n].Parent := Form1;
        VlcPlayer[VP_n].Top := 5+245*(i-1);
        VlcPlayer[VP_n].Left := 5+325*(j-1);
        VlcPlayer[VP_n].Visible := true;
        mntr[VP_n].m_x := j;
        mntr[VP_n].m_y := i;
      end;
    end;
    ClientWidth := VP_x * 325 - 5;
    ClientHeight := VP_y * 245 + 50;

    TV_URLs := TStringList.Create;
    TV_Names := TStringList.Create;
    TmpStr := TStringList.Create;

    TmpStr.Clear;
    if FileExists(Form2.Edit4.Text) then begin
      TmpStr.LoadFromFile(Form2.Edit4.Text);
      TV_URLs.Clear;
      TV_Names.Clear;
      ParseM3UPlayList(TmpStr.Text, TV_Names, TV_URLs);
    end
    else begin
      ShowMessage('   :(');
      Halt;
    end;
  end;
  URL_Count := TV_URLs.Count;
  Last_URL := 0;
  First_URL := 0;
  Last_MNTR := 0;
  for i := 1 to URL_Count do begin
    urls[i].mntr_idx := 0;
    urls[i].url := TV_URLs.Strings[i-1];
    urls[i].name := TV_Names.Strings[i-1];
  end;

  Timer1.Enabled := true;
  Timer1.Interval := 1000*Pause_switch;
  Timer_first_finish := false;
  Timer1Timer(Sender);

  for i := 1 to VP_n do begin
    mntr[i].url := '';
    mntr[i].active := false;
  end
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i, num_a: integer;
begin
  if Last_MNTR > 0 then begin
     Form1.Canvas.Pen.Color := clBtnFace;
     Form1.Canvas.Pen.Width := 5;
     Form1.Canvas.Rectangle(VlcPlayer[Last_MNTR].Left - 3, VlcPlayer[Last_MNTR].Top - 3,VlcPlayer[Last_MNTR].Left + 323, VlcPlayer[Last_MNTR].Top + 243);
  end;

//      
  if URL_Count > VP_n then begin
    num_a := 0;
//     -          !
    for i := 1 to VP_n do if mntr[i].active then inc(num_a);

    //     -        Last_URL+1
    if num_a < Num_Active then begin
       inc(Last_MNTR);
       if Last_MNTR > VP_n then Last_MNTR := 1;
       inc(Last_URL);
       if Last_URL > URL_Count then Last_URL := 1;

       mntr[Last_MNTR].active := true;
       mntr[Last_MNTR].url := urls[Last_URL].url;
       urls[Last_URL].mntr_idx := Last_MNTR;
       if Last_MNTR > 1 then VlcPlayer[Last_MNTR].SetAudioVolume(0)
                        else VlcPlayer[Last_MNTR].SetAudioVolume(50);

       Label1.Caption := ': '+ IntToStr(Last_URL)+'. '+ urls[Last_URL].name + ' ('+ urls[Last_URL].url + ')  '+IntToStr(Last_MNTR)+' ';
       Form1.Canvas.Pen.Color := clLime;
       Form1.Canvas.Pen.Width := 5;
       Form1.Canvas.Rectangle(VlcPlayer[Last_MNTR].Left - 3, VlcPlayer[Last_MNTR].Top - 3,VlcPlayer[Last_MNTR].Left + 323, VlcPlayer[Last_MNTR].Top + 243);

       VlcPlayer[Last_MNTR].Play(mntr[Last_MNTR].url);
       EXIT;
    end
    // -    
    else begin
      //      (Num_Active)       (VP_n)
      if Num_Active = VP_n then begin
       inc(Last_MNTR);
       if Last_MNTR > VP_n then Last_MNTR := 1;
       inc(Last_URL);
       if Last_URL > URL_Count then Last_URL := 1;

       mntr[Last_MNTR].active := true;
       mntr[Last_MNTR].url := urls[Last_URL].url;
       urls[Last_URL].mntr_idx := Last_MNTR;
       if Last_MNTR > 1 then VlcPlayer[Last_MNTR].SetAudioVolume(0)
                        else VlcPlayer[Last_MNTR].SetAudioVolume(50);
       Label1.Caption := ': '+IntToStr(Last_URL)+'. '+ urls[Last_URL].name + ' ('+ urls[Last_URL].url + ')  '+IntToStr(Last_MNTR)+' ';
       Form1.Canvas.Pen.Color := clLime;
       Form1.Canvas.Pen.Width := 5;
       Form1.Canvas.Rectangle(VlcPlayer[Last_MNTR].Left - 3, VlcPlayer[Last_MNTR].Top - 3,VlcPlayer[Last_MNTR].Left + 323, VlcPlayer[Last_MNTR].Top + 243);

       VlcPlayer[Last_MNTR].Play(mntr[Last_MNTR].url);
       EXIT;
      end
      else begin
       for i := 1 to URL_Count do if urls[i].mntr_idx = Last_MNTR then urls[i].mntr_idx := 0;
       inc(Last_MNTR);
       if Last_MNTR > VP_n then Last_MNTR := 1;
       inc(Last_URL);
       if Last_URL > URL_Count then Last_URL := 1;

       if Last_MNTR - Num_Active < 0 then begin
         mntr[Last_MNTR+VP_n-Num_Active].active := false;
         VlcPlayer[Last_MNTR+VP_n-Num_Active].Play('zastavka.ps');
       end
       else begin
         mntr[Last_MNTR-Num_Active].active := false;
         VlcPlayer[Last_MNTR-Num_Active].Play('zastavka.ps');
       end;

       mntr[Last_MNTR].active := true;
       mntr[Last_MNTR].url := urls[Last_URL].url;
       urls[Last_URL].mntr_idx := Last_MNTR;
       Label1.Caption := ': '+IntToStr(Last_URL)+'. '+ urls[Last_URL].name + ' ('+ urls[Last_URL].url + ')  '+IntToStr(Last_MNTR)+' ';
       Form1.Canvas.Pen.Color := clLime;
       Form1.Canvas.Pen.Width := 5;
       Form1.Canvas.Rectangle(VlcPlayer[Last_MNTR].Left - 3, VlcPlayer[Last_MNTR].Top - 3,VlcPlayer[Last_MNTR].Left + 323, VlcPlayer[Last_MNTR].Top + 243);

       VlcPlayer[Last_MNTR].Play(mntr[Last_MNTR].url);
      end;

    end;
  end
  else if URL_Count = VP_n then begin //   -   
  //         -      -     
    VlcPlayer[1].SetAudioVolume(50);
    VlcPlayer[1].Play(urls[1].url);
    //      
    Sleep(2000);
    for i := 2 to URL_Count do begin
       VlcPlayer[i].SetAudioVolume(0);
       VlcPlayer[i].Play(urls[i].url);
       Sleep(300);
    end;
    for i := 1 to URL_Count do prev_vlc_stats[i] := VlcPlayer[i].GetStats;

    Timer1.Enabled := false;

    Edit1.Visible := true;
    Button1.Visible := true;
    for i := 2 to 18 do (FindComponent('Label'+IntToStr(i)) as TLabel).Visible := true;

    Timer2.Enabled := true;
  end
end;


procedure TForm1.Timer2Timer(Sender: TObject);
var
//  stat:libvlc_media_stats_t;
  i: integer;
begin
  for i := 1 to URL_Count do begin
    vlc_stats[i] := VlcPlayer[i].GetStats;
    if (vlc_stats[i].i_demux_corrupted > prev_vlc_stats[i].i_demux_corrupted) or
       (vlc_stats[i].i_demux_discontinuity > prev_vlc_stats[i].i_demux_discontinuity) or
       (vlc_stats[i].i_lost_pictures > prev_vlc_stats[i].i_lost_pictures) or
       (vlc_stats[i].i_lost_abuffers > prev_vlc_stats[i].i_lost_abuffers) then Form1.Canvas.Pen.Color := clRed;

    Form1.Canvas.Pen.Width := 3;
    Form1.Canvas.Rectangle(VlcPlayer[i].Left - 2, VlcPlayer[i].Top - 2,VlcPlayer[i].Left + 322, VlcPlayer[i].Top + 242);
    prev_vlc_stats[i] := vlc_stats[i];
  end;
  i := StrToInt(Label18.Caption);
  Label3.Caption := IntToStr(vlc_stats[i].i_read_bytes)+' Read bytes';
  Label4.Caption := IntToStr(vlc_stats[i].i_demux_read_bytes)+' Demux read bytes';
  Label5.Caption := IntToStr(vlc_stats[i].i_demux_corrupted)+' Demux corrupted';
  Label6.Caption := IntToStr(vlc_stats[i].i_demux_discontinuity)+' Demux discontinuity';
  Label7.Caption := IntToStr(vlc_stats[i].i_decoded_video)+' Decoded video';
  Label8.Caption := IntToStr(vlc_stats[i].i_decoded_audio)+' Decoded audio';
  Label9.Caption := IntToStr(vlc_stats[i].i_displayed_pictures)+' Displayed pictures';
  Label10.Caption := IntToStr(vlc_stats[i].i_lost_pictures)+' Lost pictures';
  Label11.Caption := IntToStr(vlc_stats[i].i_played_abuffers)+' Played ABuffers';
  Label12.Caption := IntToStr(vlc_stats[i].i_lost_abuffers)+' Lost ABuffers';
  Label13.Caption := IntToStr(vlc_stats[i].i_sent_packets)+' Sent packets';
  Label14.Caption := IntToStr(vlc_stats[i].i_sent_bytes)+' Sent bytes';
  Label15.Caption := FloatToStr(vlc_stats[i].f_input_bitrate)+' Input bitrate';
  Label16.Caption := FloatToStr(vlc_stats[i].f_demux_bitrate)+' Demux bitrate';
  Label17.Caption := FloatToStr(vlc_stats[i].f_send_bitrate)+' Send bitrate';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: integer;
begin
  i := StrToInt(Edit1.Text);
  if (i > 0) and (i <= URL_Count) then begin
    VlcPlayer[StrToInt(Label18.Caption)].SetAudioVolume(0);
    Label18.Caption := IntToStr(i);
    VlcPlayer[i].SetAudioVolume(50);
  end;
end;

end.
